;-------------------------------------------------------------------------
;-------------------------------------------------------------------------
.386p
CSEG segment use16
assume cs:cseg, ds:cseg, ss:cseg, es:cseg
	org	100h
start:
;-------------------------------------------------------------------------

Code16GDT = 8
Data16GDT = 16
Data32GDT = 24

Set4Gig:
	in	al, 92h
	or	al, 02h
	out	92h, al
	;call	enablea20

        mov     eax,cr0         ; check for V86 mode
        ror     eax,1
        jc      leave4gb        ; exit routine if V86 mode is set.

        mov     ax,cs           ; set up GDT for this code segment
	mov	Code, ax
        mov     ds,ax
        movzx   eax,ax
        shl     eax,4
        add     dword ptr ds:GDTptr+2,eax
        lgdt    fword ptr ds:GDTptr

        mov     ax,cs
        and     eax,65535
        shl     eax,4
        mov     word ptr ds:Mem32_GDT[Code16GDT+2],ax
        mov     word ptr ds:Mem32_GDT[Data16GDT+2],ax
        ror     eax,16
        mov     byte ptr ds:Mem32_GDT[Code16GDT+4],al
        mov     byte ptr ds:Mem32_GDT[Data16GDT+4],al
        mov     byte ptr ds:Mem32_GDT[Code16GDT+7],ah
        mov     byte ptr ds:Mem32_GDT[Data16GDT+7],ah

        cli                     ; no interrupts

        mov     eax,cr0         ; set protected mode
        or      al,1
        mov     cr0,eax

        db      0eah            ; far jump to pmode label
        dw      offset pmode
        dw      Code16GDT

pmode:  mov     ax,Data32GDT    ; now we are in protected mode
        mov     ds,ax           ; set all selector limits to 4 GB
        mov     es,ax
        mov     fs,ax
        mov     gs,ax

        mov     eax,cr0         ; restore real mode
        and     al,0feh
        mov     cr0,eax

        db      0eah            ; far jump to rmode label
        dw      offset rmode
Code	dw      ?

rmode:  clc                     ; now we are back in real mode, zero carry
        sti                     ; to indicate ok and enable interrupts
                
leave4gb:
        ret

;--------------------------------------------------------------------------

mem32_GDT       dw      4 dup(0)

        dw      0ffffh,0ffh,9a00h,0
        dw      0ffffh,0ffh,9200h,0
        dw      0ffffh,0ffh,9200h,8fh

GDTptr label fword
        dw      offset GDTptr-1-offset Mem32_GDT
        dd      offset Mem32_GDT ; Absolute adress GDTtable
        dw      0

enablea20:
        mov     al,0d1h
        out     64h,al
        call    a20wait
        mov     al,0dfh
        out     60h,al
        call    a20wait
        mov     al,0ffh
        out     64h,al
        call    a20wait
        ret

a20wait:
        in      al,64h
        jmp     $+2
        and     al,2
        jnz     a20wait
        ret

;--------------------------------------------------------------------------
	CSEG	ends
	end	start
;--------------------------------------------------------------------------